package de.ugoe.cs.rwm.mocci.connector;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public final class ResultproviderHelper {
	Properties props;
	private final static String FILENAME = "resultprovider.properties";
	
	public ResultproviderHelper() {
		loadProperties();
	}
	
	/**
	 * Getter method for providing the properties of this ResultProviderHelper.
	 * Properties will be read from local file resultprovider.properties.
	 * @return The properties
	 */
	public Properties getProperties() {
		if (props == null)
			loadProperties();
		
		return props;
}
	
	private void loadProperties() {
		props = new Properties();
    	InputStream input = null;

    	try {
    		input = this.getClass().getClassLoader().getResourceAsStream(FILENAME);	
    		props.load(input);
    		
    	} catch (IOException ex) {
    		ex.printStackTrace();
        } finally{
        	if(input!=null){
        		try {
				input.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
        	}
        }		
}
	
	
}
